# booleanhelper.rb
# april 9, 2011
#
# Description: Quick scale up a small model (mm size) to do boolean or lathe operations.
# This is usefull since sketchup can not work with very small faces.
# After the operations are finished you can scale your model down to get back to the original dimensions
#
# 
# This plugin was conceived by me, rene van Asperen with great help from TIG  and Thomas from
# the SketchUcation forums.
#
#
# USE OF THIS SOFTWARE IS AT YOUR OWN RISK!
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.




require 'sketchup.rb'

#=============================================================================
module Bhelper

# $liquidsscalefactor=1000

	
class Getinfo
	
	def initialize() 

		prompts = ["Enter scalefactor   "]
		values = [1000]
		
		results = UI.inputbox prompts, values, "Scalefactor."
		return if not results
		@lsf, = results
		
		UI.messagebox @lsf.class
		

		

end

end


	




class Kleiner
	
	def initialize() 
	UI.messagebox @lsf.class
        model = Sketchup.active_model

        entities = model.active_entities
        selection = model.selection

         trans = Geom::Transformation.scaling(ORIGIN, 1.0/@lsf)

        entities.transform_entities(trans, selection.to_a)
	#view = Sketchup.active_model.active_view
	
	#new_view = view.zoom_extents
	end
end





class Groter
	
	def initialize() 
	UI.messagebox @lsf.class
        model = Sketchup.active_model

        

        entities= model.active_entities
        selection = model.selection

        trans = Geom::Transformation.scaling(ORIGIN, @lsf)
        

        entities.transform_entities(trans, selection.to_a)
	#view = Sketchup.active_model.active_view
	
	#new_view = view.zoom_extents
	end
end


 

#=============================================================================
if( not $booleanhelper_menu_loaded )
    add_separator_to_menu("Plugins")
        new_menu = UI.menu("Plugins").add_submenu("Boolean helper")
        new_toolbar = UI::Toolbar.new("Boolean helper")
        plugins = Sketchup.find_support_file("Plugins")
        imgdir = File.join(plugins, "Booleanhelper")

        cmd = UI::Command.new("Scale with factor 0.001") {Bhelper::Kleiner.new() }
        cmd.small_icon = File.join(imgdir, "smaller.png")
        cmd.large_icon = File.join(imgdir, "smallerL.png")
	cmd.tooltip = "Scale with factor 0.001"
        cmd.menu_text = "Scale with factor 0.001"

    new_menu.add_item(cmd)
    new_toolbar.add_item(cmd)

        cmd = UI::Command.new("Scale with factor 1000") {Bhelper::Groter.new() }
        cmd.small_icon = File.join(imgdir, "bigger.png")
        cmd.large_icon = File.join(imgdir, "biggerL.png")
	cmd.tooltip = "Scale with factor 1000"
        cmd.menu_text = "Scale with factor 1000"

    new_menu.add_item(cmd)
    new_toolbar.add_item(cmd)
    
    cmd = UI::Command.new("set scale factor") {Bhelper::Getinfo.new()}
	
     new_menu.add_item(cmd)
     
        new_toolbar.show

        $booleanhelper_menu_loaded = true
end 

end #module




